View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.coap.resource;
    21
    22  import org.apache.mina.api.IoSession;
    23  import org.apache.mina.coap.CoapMessage;
    24
    25  /**
    26   * A resource handler for a given path.
    27   *
    28   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    29   */
    30  public interface ResourceHandler {
    31
    32      /**
    33       * The path served by this resource handler.
    34       */
    35      public String getPath();
    36
    37      /**
    38       * Detailed title for this path (or <code>null</code>). See http://datatracker.ietf.org/doc/rfc6690/
    39       */
    40      public String getTittle();
    41
    42      /**
    43       * Interface name of this resource (or <code>null</code>), can be an URL to a WADL file. See
    44       * http://datatracker.ietf.org/doc/rfc6690/
    45       */
    46      public String getInterface();
    47
    48      /**
    49       * Resource type (or <code>null</code>). See http://datatracker.ietf.org/doc/rfc6690/
    50       */
    51      public String getResourceType();
    52
    53      /**
    54       * Generate the response for this request.
    55       *
    56       * @param request the request to serve
    57       * @param session the session which receive the request
    58       * @return the response
    59       */
    60      public CoapResponse handle(CoapMessage request, IoSession session);
    61  }